package com.bytesw.bytebot.controller.airport;


import com.bytesw.bytebot.dto.AgenteReservaDTO;
import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.service.AgenteServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/service/agente")
public class AgenteController extends BasicXDFController<AgenteReservaDTO,Integer> {

    @Autowired
    private AgenteServiceImpl agenteService;
    @Autowired
    private GsonBuilder gsonBuilder;
    public AgenteController(AgenteServiceImpl agenteService){
        super(agenteService);
    }
    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<AgenteReservaDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<AgenteReservaDTO> value = new DataPage<>();
        value.setData(agenteService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }
}
