package com.bytesw.bytebot.controller.airport;


import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.EscalaDTO;
import com.bytesw.bytebot.dto.ItinerarioReservaDTO;
import com.bytesw.bytebot.model.airport.Escala;
import com.bytesw.bytebot.repository.IEscalaDAO;
import com.bytesw.bytebot.repository.IItinerarioReservaDAO;
import com.bytesw.bytebot.service.EscalaServiceImpl;
import com.bytesw.bytebot.service.ItinerarioReservaServiceImpl;
import com.bytesw.bytebot.service.VueloServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/service/escala")
public class EscalaController extends BasicXDFController<EscalaDTO,Integer> {

    @Autowired
    private EscalaServiceImpl escalaService;

    @Autowired
    private VueloServiceImpl vueloService;

    @Autowired
    private IItinerarioReservaDAO itinerarioReservaDAO;
    @Autowired
    private IEscalaDAO iEscalaDAO;
    @Autowired
    private GsonBuilder gsonBuilder;

    public EscalaController(EscalaServiceImpl escalaService){
        super(escalaService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<EscalaDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<EscalaDTO> value = new DataPage<>();
        value.setData(escalaService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    @GetMapping("listar/{id}/vuelos")
    public ResponseEntity<String> listarVuelosByEscalas(@PathVariable(value = "id") Integer id) {
        return new ResponseEntity(vueloService.getById(id).getEscalas(), HttpStatus.OK);
    }

    @PostMapping("/reserva/{id}")
    public ResponseEntity<String> addEscala(@PathVariable(value = "id") Integer id, @RequestBody Escala escalaRequest) {
        Escala escala = itinerarioReservaDAO.findById(id).map(itinerarioReserva -> {
            Integer escalaId = escalaRequest.getId();
            Escala _esc = iEscalaDAO.getOne(escalaId);
            itinerarioReserva.addEscala(_esc);
            itinerarioReservaDAO.save(itinerarioReserva);
            return _esc;
        }).orElseThrow(null);

        return new ResponseEntity( HttpStatus.OK);
    }


}