package com.bytesw.bytebot.controller.airport;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.PagoDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.model.airport.Pago;
import com.bytesw.bytebot.repository.IItinerarioReservaDAO;
import com.bytesw.bytebot.repository.IPagoDAO;
import com.bytesw.bytebot.service.PagoServiceImpl;
import com.bytesw.bytebot.service.PasajeroServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/service/pago")
public class PagoController extends BasicXDFController<PagoDTO,Integer> {
    @Autowired
    private PagoServiceImpl pagoService;

    @Autowired
    private GsonBuilder gsonBuilder;

    @Autowired
    private IItinerarioReservaDAO itinerarioReservaDAO;

    @Autowired
    private IPagoDAO pagoDAO;
    public PagoController(PagoServiceImpl pagoService){
        super(pagoService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<PagoDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<PagoDTO> value = new DataPage<>();
        value.setData(pagoService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    @PostMapping("/reservas/{id}/pagos")
    public ResponseEntity<String> addTag(@PathVariable(value = "id") Integer id, @RequestBody Pago pagoRequest) {
        Pago pago = itinerarioReservaDAO.findById(id).map(itinerarioReserva -> {
            Integer pagoId = pagoRequest.getId();
            Pago _pag = pagoDAO.findById(pagoId).orElseThrow(null);
            itinerarioReserva.addPago(_pag);
            itinerarioReservaDAO.save(itinerarioReserva);
            return _pag;
        }).orElseThrow(null);
        return new ResponseEntity( HttpStatus.OK);
    }
}
