package com.bytesw.bytebot.controller.airport;



import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.service.PasajeroServiceImpl;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.controller.XDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/service/pasajero")
public class PasajeroController extends BasicXDFController<PasajeroDTO,Integer> {
    @Autowired
    private PasajeroServiceImpl pasajeroService;

    @Autowired
    private GsonBuilder gsonBuilder;

    public PasajeroController(PasajeroServiceImpl pasajeroService){
        super(pasajeroService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<PasajeroDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<PasajeroDTO> value = new DataPage<>();
        value.setData(pasajeroService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    public ResponseEntity<String> findAll(HttpServletRequest req) {
        return new ResponseEntity(this.pasajeroService.getAll(), HttpStatus.OK);
    }

}
