package com.bytesw.bytebot.controller.airport;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.dto.VueloDTO;
import com.bytesw.bytebot.service.PasajeroServiceImpl;
import com.bytesw.bytebot.service.VueloServiceImpl;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.controller.XDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/service/vuelo")
public class VueloController extends XDFController<VueloDTO,Integer> {
    @Autowired
    private VueloServiceImpl vueloService;
    @Autowired
    private AeropuertoServiceImpl aeropuertoService;
    @Autowired
    private GsonBuilder gsonBuilder;

    public VueloController(VueloServiceImpl vueloService){
        super(vueloService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<VueloDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<VueloDTO> value = new DataPage<>();
        value.setData(vueloService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }
    public ResponseEntity<String> findAll(HttpServletRequest req) {
        return new ResponseEntity(this.vueloService.getAll(), HttpStatus.OK);
    }

    public ResponseEntity<String> findOne(@PathVariable("id") Integer id, HttpServletRequest req) {
        return new ResponseEntity(this.vueloService.getById(id), HttpStatus.OK);
    }
}