package com.bytesw.bytebot.model.airport;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import org.hibernate.envers.Audited;

import javax.persistence.*;
import java.io.Serializable;
import java.util.List;


@Entity
@Table(name="airports")
@Getter
@Setter
@EqualsAndHashCode
@ToString
public class Aeropuerto implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    @Column(name="airport_code")
    private String codigo;

    @Column(name="airport_name")
    private String nombre;

    @Column(name="airport_location")
    private String localizacion;

    @Column(name="other_details")
    private String detalles;

    @OneToMany(mappedBy = "codigoAeropuertoOrigen", cascade = CascadeType.ALL)
    private List<Vuelo> vuelos;

    @OneToMany(mappedBy = "codigoAeropuertoDestino", cascade = CascadeType.ALL)
    private List<Vuelo> vuelosDes;

    @OneToMany(mappedBy = "codigoAeropuertoOrigen", cascade = CascadeType.ALL)
    private List<Escala> escalas;

    @OneToMany(mappedBy = "codigoAeropuertoDestino", cascade = CascadeType.ALL)
    private List<Escala> escalasDes;
}
