package com.bytesw.bytebot.service;

import com.bytesw.xdf.dao.rsql.CustomRsqlVisitor;
import com.bytesw.xdf.sql.beans.Pagination;
import com.bytesw.xdf.sql.beans.SortField;
import cz.jirutka.rsql.parser.RSQLParser;
import cz.jirutka.rsql.parser.ast.Node;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;

import java.util.ArrayList;
import java.util.List;


public abstract class CustomPaginationService<T> {

    public Specification<T> createSpecification(final String filterExpression) {
        Node rootNode = new RSQLParser().parse(filterExpression);
        return rootNode.accept(new CustomRsqlVisitor<>());
    }

    public Sort createSort(Pagination pagination) {
        List<Sort.Order> orderList = new ArrayList<>();
        for (SortField sortField : pagination.getSortFields()) {
            if ("asc".equalsIgnoreCase(sortField.getDirection())) {
                orderList.add(Sort.Order.asc(sortField.getField()));
            } else {
                orderList.add(Sort.Order.desc(sortField.getField()));
            }
        }
        return Sort.by(orderList);
    }

}