package com.bytesw.bytebot.service;


import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.model.airport.Aeropuerto;
import com.bytesw.bytebot.model.airport.ItinerarioReserva;
import com.bytesw.bytebot.model.airport.Pasajero;
import com.bytesw.bytebot.repository.IAeropuertoDAO;
import com.bytesw.bytebot.repository.IItinerarioReservaDAO;
import com.bytesw.bytebot.repository.IPasajeroDAO;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class PasajeroServiceImpl extends XDFService<Pasajero, PasajeroDTO,Integer>{

    protected PasajeroServiceImpl(IPasajeroDAO pasajeroDAO){
        super(pasajeroDAO);
    }

    @Override
    protected PasajeroDTO toBean(Pasajero model){
        PasajeroDTO bean = new PasajeroDTO();
        BeanUtils.copyProperties(model,bean);
        return bean;
    }

    @Override
    protected Pasajero toModel(Pasajero model, PasajeroDTO bean){
        if(model == null){
            model = new Pasajero();
        }
        BeanUtils.copyProperties(bean,model);
        return model;
    }

}
