package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.dto.EscalaDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.dto.VueloDTO;
import com.bytesw.bytebot.model.airport.Aeropuerto;
import com.bytesw.bytebot.model.airport.Pasajero;
import com.bytesw.bytebot.model.airport.Vuelo;
import com.bytesw.bytebot.repository.IPasajeroDAO;
import com.bytesw.bytebot.repository.IVueloDAO;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class VueloServiceImpl extends XDFService<Vuelo, VueloDTO,Integer> {
    protected VueloServiceImpl(IVueloDAO vueloDAO){
        super(vueloDAO);
    }

    @Autowired
    private AeropuertoServiceImpl aeropuertoService;

    @Override
    protected VueloDTO toBean(Vuelo model){
        VueloDTO bean = new VueloDTO();
        BeanUtils.copyProperties(model,bean);
        bean.setCodigoAeropuertoOrigen(model.getCodigoAeropuertoOrigen().getId());
        bean.setCodigoAeropuertoDestino(model.getCodigoAeropuertoDestino().getId());
        bean.setAeropuertoOrigen(model.getCodigoAeropuertoOrigen().getCodigo());
        bean.setAeropuertoDestino(model.getCodigoAeropuertoDestino().getCodigo());
        bean.setEscalas(model.getEscalas());
        return bean;
    }

    @Override
    protected Vuelo toModel(Vuelo model, VueloDTO bean){
        if(model == null){
            model = new Vuelo();
        }
        BeanUtils.copyProperties(bean,model);
        AeropuertoDTO aeropuertoDTO = aeropuertoService.getById(bean.getCodigoAeropuertoOrigen());
        AeropuertoDTO aeropuertoDTO2 = aeropuertoService.getById(bean.getCodigoAeropuertoDestino());
        model.setCodigoAeropuertoOrigen(aeropuertoService.toModel(new Aeropuerto(),aeropuertoDTO));
        model.setCodigoAeropuertoDestino(aeropuertoService.toModel(new Aeropuerto(), aeropuertoDTO2));
        return model;
    }

}
